%Chapitre 3
\section{Gitlab}
\frame{\sectionpage}

\subsection{Introduction}

\begin{frame}{Introduction}

    \begin{center}
        \begin{figure}[h]
            \includegraphics[width=0.5\textwidth]{gitlab.png}
            \caption{Gitlab logo}
        \end{figure}
    \end{center}

    \begin{block}{What is Gitlab?}
        A collaboration platform with features such as issue tracker, source code management, and its own built-in CI/CD tool.

        Also offers wikis as well as Markdown-based readmes.
    \end{block}

    \begin{alertblock}{Inria Gitlab}
        Corresponds with \textbf{Gitlab CE}: \href{https://gitlab.inria.fr/}{https://gitlab.inria.fr/}
    \end{alertblock}
\end{frame}

\subsection{Global interface}

\begin{frame}{Global interface}
    \begin{columns}
        \column{0.625\textwidth}
        \begin{center}
            \begin{figure}[h]
                \includegraphics[width=1.0\textwidth]{structure_gitlab_repo.png}
                \caption{Gitlab repository structure}
            \end{figure}
        \end{center}
        \column{0.3\textwidth}
        \begin{block}{Structure}

            \tiny

            \begin{itemize}
                \item{\textbf{A personal toolbar:} Which envolves operations relation with your user.}

                \item{\textbf{Project info:} General information of the project.}

                \item{\textbf{Project toolbar:} With all the operations related with the current project.}

                \item{\textbf{Project description:} A description of the project.}

                \item{\textbf{Code:} The code structure of the code.}

                \item{\textbf{Branches:} Branches operations of the project.}
            \end{itemize}

        \end{block}
    \end{columns}
\end{frame}

\subsection{Github flow}

\begin{frame}{Github flow}
    \begin{center}
        \begin{figure}[h]
            \includegraphics[width=0.75\textwidth]{github_flow.png}
            \caption{Github flow}
        \end{figure}
    \end{center}

    \begin{block}{Github flow}

        \tiny

        \begin{enumerate}
            \item{\textbf{Create a branch:} Containing the changes you want to incorporate to the code.}

            \item{\textbf{Add commits:} Once your branch has been created, it's time to start making changes.}

            \item{\textbf{Open a Merge Request:} Merge Requests initiate discussion about your commits.}

            \item{\textbf{Discuss and review your code:} The person or team reviewing your changes may have questions or comments. }

            \item{\textbf{Deploy (CI/CD):} You can deploy from a branch for final testing in production before merging to main.}

            \item{\textbf{Merge:} Now that your changes have been verified in production, it is time to merge.}
        \end{enumerate}

    \end{block}
\end{frame}

\subsection{Branches}

\begin{frame}{Branches}
    \begin{center}
        \begin{figure}[h]
            \includegraphics[width=0.78\textwidth]{branches_gitlab.png}
            \caption{Gitlab branches}
        \end{figure}
    \end{center}
\end{frame}

\begin{frame}{Create branches/Access to the wiki}
    \begin{columns}
        \column{0.45\textwidth}
        \begin{center}
            \begin{figure}[h]
                \includegraphics[width=1.0\textwidth]{create_branch.png}
                \caption{Create a new branch}
            \end{figure}
        \end{center}
        \column{0.45\textwidth}
        \begin{center}
            \begin{figure}[h]
                \includegraphics[width=1.0\textwidth]{wiki.png}
                \caption{Access to the wiki}
            \end{figure}
        \end{center}
    \end{columns}
\end{frame}

\subsection{Create issues}

\begin{frame}{Create issues}
    \begin{columns}
        \column{0.45\textwidth}
        \begin{center}
            \begin{figure}[h]
                \includegraphics[width=1.0\textwidth]{new_issue.png}
                \caption{New issue}
            \end{figure}
        \end{center}
        \column{0.45\textwidth}
        \begin{center}
            \begin{figure}[h]
                \includegraphics[width=1.0\textwidth]{issue_with_template.png}
                \caption{Issue with template}
            \end{figure}
        \end{center}
    \end{columns}
\end{frame}

\subsection{Create merge requests}

\begin{frame}{Create merge requests (I)}
    \begin{columns}
        \column{0.5\textwidth}
        \begin{center}
            \begin{figure}[h]
                \includegraphics[width=1.0\textwidth]{merge_request.png}
                \caption{Gitlab repository structure}
            \end{figure}
        \end{center}
        \column{0.4\textwidth}
        \begin{block}{Structure}

            \tiny

            \begin{itemize}
                \item{\textbf{Author:} The author of the MR. It cannot approve itself, and requires the approval of a mantainer in order to merge the MR (which must be performed by the maintainer too due to the Gitlab version considered in Inria).}

                \item{\textbf{Title:} Title of the MR.}

                \item{\textbf{Description:} What is the pourpose of the given MR, what changes introduces, what is the scope...}

                \item{\textbf{Project description:} A description of the project.}

                \item{\textbf{Label:} Labels which describe the MR.}

                \item{\textbf{Assigned:} The person responsible the given MR.}

                \item{\textbf{Reviewers:} The responsibles to review the changes in the code.}
            \end{itemize}

        \end{block}
    \end{columns}
\end{frame}

\begin{frame}{Create merge requests (II)}
    \begin{columns}
        \column{0.45\textwidth}
        \begin{center}
            \begin{figure}[h]
                \includegraphics[width=1.0\textwidth]{new_mr.png}
                \caption{New \textbf{MR}}
            \end{figure}
        \end{center}
        \begin{center}
            \begin{figure}[h]
                \includegraphics[width=1.0\textwidth]{selecting_branch_MR.png}
                \caption{Selecting branch}
            \end{figure}
        \end{center}
        \column{0.45\textwidth}
        \begin{center}
            \begin{figure}[h]
                \includegraphics[width=1.0\textwidth]{creating_mr.png}
                \caption{Creating \textbf{MR}}
            \end{figure}
        \end{center}
    \end{columns}
\end{frame}

\begin{frame}{Create merge requests (III)}
    \begin{columns}
        \column{0.45\textwidth}
        \begin{center}
            \begin{figure}[h]
                \includegraphics[width=1.0\textwidth]{mr_commits.png}
                \caption{Commits}
            \end{figure}
        \end{center}
        \begin{center}
            \begin{figure}[h]
                \includegraphics[width=1.0\textwidth]{mr_pipelines.png}
                \caption{Pipelines}
            \end{figure}
        \end{center}
        \column{0.45\textwidth}

        \tiny

        \begin{itemize}
            \item{\textbf{Changes:} The files changed in the \textbf{MR}, here it is possible to add comments or request that block the \textbf{MR} until these are solved.}

            \item{\textbf{Commits:} List of commits that include the \textbf{MR}.}

            \item{\textbf{Pipelines:} Pipelines that define the \textbf{CI}. These are mandatory in order to be possible to approve the \textbf{MR}.}
        \end{itemize}

        \begin{center}
            \begin{figure}[h]
                \includegraphics[width=1.0\textwidth]{mr_changes.png}
                \caption{Changes}
            \end{figure}
        \end{center}
    \end{columns}
\end{frame}

\subsection{Additional features}

\begin{frame}{Additional features}
    \begin{columns}
        \column{0.45\textwidth}

        \begin{center}
            \begin{figure}[h]
                \includegraphics[width=1.0\textwidth]{mention_other_developers.png}
                \caption{Mention other developers}
            \end{figure}
        \end{center}

        \begin{block}{Mention other developers}
            \tiny

            In order to mention in the issues or \textbf{MR} to any user, just write @ followed with the user anme we want to mention.

            Additionally to mention that the comments are full \textit{Markdown}, so you can do anything it is possible to do in \textit{Markdown} as adding pictures, lists, tables, etc...
        \end{block}


        \column{0.45\textwidth}

        \begin{center}
            \begin{figure}[h]
                \includegraphics[width=1.0\textwidth]{web_ide.png}
                \caption{Web IDE}
            \end{figure}
        \end{center}

        \vspace{-0.65cm}

        \begin{block}{Web IDE}

            \tiny

            It has the following features:

            \begin{itemize}
                \item{\textbf{File finder}}

                \item{\textbf{Syntax highlighting}}

                \item{\textbf{Commit changes}}

                \item{\textbf{Reviewing changes}}

                \item{\textbf{Switching branches}}

                \item{\textbf{Markdown editing}}
            \end{itemize}
        \end{block}

    \end{columns}
\end{frame}

\subsection{Example \textit{Github} flow}

\begin{frame}{Example \textit{Github} flow}

    \begin{alertblock}{}
        See \texttt{git-example-tutorial/examples/github-flow/}
    \end{alertblock}

    \footnotesize
    \begin{block}{Steps}
        \begin{enumerate}
            \item Create a new branch for the editing: \texttt{git checkout -b name}
            \item Go to the test folder: \texttt{git-example-tutorial/tests/}
            \item Edit the file so it fails
            \item Push the changes \texttt{git commit -a -m 'Making the test fail'} and then \texttt{git push --set-upstream origin name}
            \item Open a \textbf{MR}. See next slide
            \begin{itemize}
                \item Discuss the MR
                \item Correct the errors
                \item Now test passes
                \item Resolve issues
                \item Approve and  merge
            \end{itemize}
        \end{enumerate}
    \end{block}

\end{frame}

\begin{frame}{Example \textit{Github} flow. Create \textbf{MR} (I)}
    \begin{columns}
        \column{0.45\textwidth}
        \begin{center}
            \begin{figure}[h]
                \includegraphics[width=1.0\textwidth]{create_mr_workflow.png}
                \caption{Create \textbf{MR}}
            \end{figure}
        \end{center}
        \begin{center}
            \begin{figure}[h]
                \includegraphics[width=1.0\textwidth]{mr_creation_workflow.png}
                \caption{\textbf{MR} creation}
            \end{figure}
        \end{center}
        \column{0.45\textwidth}
        \begin{center}
            \begin{figure}[h]
                \includegraphics[width=1.0\textwidth]{ci_fails.png}
                \caption{\textbf{CI} fails}
            \end{figure}
        \end{center}
        \begin{center}
            \begin{figure}[h]
                \includegraphics[width=1.0\textwidth]{comments_workflow.png}
                \caption{Comments}
            \end{figure}
        \end{center}
    \end{columns}
\end{frame}

\begin{frame}{Example \textit{Github} flow. Create \textbf{MR} (II)}
    \begin{columns}
        \column{0.45\textwidth}
        \begin{center}
            \begin{figure}[h]
                \includegraphics[width=1.0\textwidth]{open_web_ide.png}
                \caption{Open web \textbf{IDE}}
            \end{figure}
        \end{center}
        \begin{center}
            \begin{figure}[h]
                \includegraphics[width=1.0\textwidth]{edit_with_web_ide.png}
                \caption{Edit with Web \textbf{IDE}}
            \end{figure}
        \end{center}
        \column{0.45\textwidth}
        \begin{center}
            \begin{figure}[h]
                \includegraphics[width=1.0\textwidth]{test_passes.png}
                \caption{\textbf{CI} success}
            \end{figure}
        \end{center}
        \begin{center}
            \begin{figure}[h]
                \includegraphics[width=1.0\textwidth]{resolve_issues.png}
                \caption{Resolve issues}
            \end{figure}
        \end{center}
    \end{columns}
\end{frame}

\begin{frame}{Example \textit{Github} flow. Create \textbf{MR} (III)}
    \begin{columns}
        \column{0.45\textwidth}
        \begin{center}
            \begin{figure}[h]
                \includegraphics[width=1.0\textwidth]{comment_resolve_issues.png}
                \caption{Comment in resolved issues}
            \end{figure}
        \end{center}
        \column{0.45\textwidth}
        \begin{center}
            \begin{figure}[h]
                \includegraphics[width=1.0\textwidth]{merge_workflow.png}
                \caption{Merge branch}
            \end{figure}
        \end{center}
    \end{columns}
\end{frame}
